GDAL

- Main Page
- Related Pages
- Classes
- Files
- Download
- Issue Tracker

- File List
- File Members

Classes | Typedefs | Enumerations | Functions
ogr_geometry.h File Reference

Simple feature geometry classes. More...

`#include "cpl_conv.h"`
`#include "cpl_json.h"`
`#include "ogr_core.h"`
`#include "ogr_spatialref.h"`
`#include <memory>`

Go to the source code of this file.

## Classes
struct | OGRWktOptions
| Options for formatting WKT output. More...
class | OGRRawPoint
| Simple container for a position. More...
class | IOGRGeometryVisitor
| OGRGeometry visitor interface. More...
class | OGRDefaultGeometryVisitor
| OGRGeometry visitor default implementation. More...
class | IOGRConstGeometryVisitor
| OGRGeometry visitor interface. More...
class | OGRDefaultConstGeometryVisitor
| OGRGeometry visitor default implementation. More...
class | OGRGeometry
| Abstract base class for all geometry classes. More...
class | OGRPoint
| Point class. More...
class | OGRPointIterator
| Interface for a point iterator. More...
class | OGRCurve
| Abstract curve base class for OGRLineString, OGRCircularString and OGRCompoundCurve. More...
class | OGRSimpleCurve
| Abstract curve base class for OGRLineString and OGRCircularString. More...
class | OGRLineString
| Concrete representation of a multi-vertex line. More...
class | OGRLinearRing
| Concrete representation of a closed ring. More...
class | OGRCircularString
| Concrete representation of a circular string, that is to say a curve made of one or several arc circles. More...
class | OGRCompoundCurve
| Utility class to store a collection of curves. More...
class | OGRSurface
| Abstract base class for 2 dimensional objects like polygons or curve polygons. More...
class | OGRCurvePolygon
| Concrete class representing curve polygons. More...
class | OGRPolygon
| Concrete class representing polygons. More...
class | OGRTriangle
| Triangle class. More...
class | OGRGeometryCollection
| A collection of 1 or more geometry objects. More...
class | OGRMultiSurface
| A collection of non-overlapping OGRSurface. More...
class | OGRMultiPolygon
| A collection of non-overlapping OGRPolygon. More...
class | OGRPolyhedralSurface
| PolyhedralSurface class. More...
class | OGRTriangulatedSurface
| TriangulatedSurface class. More...
class | OGRMultiPoint
| A collection of OGRPoint. More...
class | OGRMultiCurve
| A collection of OGRCurve. More...
class | OGRMultiLineString
| A collection of OGRLineString. More...
class | OGRGeometryFactory
| Create geometry objects from well known text/binary. More...
class | OGRGeometryFactory::TransformWithOptionsCache
| Opaque class used as argument to transformWithOptions() More...

## Typedefs
typedef struct GEOSGeom_t * | GEOSGeom
| GEOS geometry type.
typedef struct GEOSContextHandle_HS * | GEOSContextHandle_t
| GEOS context handle type.
typedef void | sfcgal_geometry_t
| SFCGAL geometry type.
typedef std::unique_ptr< OGRGeometry, OGRGeometryUniquePtrDeleter > | OGRGeometryUniquePtr
| Unique pointer type for OGRGeometry. More...
typedef struct _OGRPreparedGeometry | OGRPreparedGeometry
| Prepared geometry API (needs GEOS >= 3.1.0)
typedef std::unique_ptr< OGRPreparedGeometry, OGRPreparedGeometryUniquePtrDeleter > | OGRPreparedGeometryUniquePtr
| Unique pointer type for OGRPreparedGeometry. More...

## Enumerations
enum | OGRWktFormat { OGRWktFormat::F, OGRWktFormat::G, OGRWktFormat::Default }
| WKT Output formatting options. More...

## Functions
OGRwkbGeometryType | OGRFromOGCGeomType (const char *pszGeomType)
| Map OGCgeometry format type to corresponding OGR constants. More...
const char * | OGRToOGCGeomType (OGRwkbGeometryType eGeomType)
| Map OGR geometry format constants to corresponding OGC geometry type. More...
int | OGRHasPreparedGeometrySupport ()
| Returns if GEOS has prepared geometry support. More...
OGRPreparedGeometry * | OGRCreatePreparedGeometry (const OGRGeometry *poGeom)
| Creates a prepared geometry. More...
void | OGRDestroyPreparedGeometry (OGRPreparedGeometry *poPreparedGeom)
| Destroys a prepared geometry. More...
int | OGRPreparedGeometryIntersects (const OGRPreparedGeometry *poPreparedGeom, const OGRGeometry *poOtherGeom)
| Returns whether a prepared geometry intersects with a geometry. More...
int | OGRPreparedGeometryContains (const OGRPreparedGeometry *poPreparedGeom, const OGRGeometry *poOtherGeom)
| Returns whether a prepared geometry contains a geometry. More...

## Detailed Description

Simple feature geometry classes.

## Typedef Documentation

typedef std::unique_ptr<OGRGeometry, OGRGeometryUniquePtrDeleter> OGRGeometryUniquePtr

Unique pointer type for OGRGeometry.

Since
  GDAL 2.3

typedef std::unique_ptr<OGRPreparedGeometry, OGRPreparedGeometryUniquePtrDeleter> OGRPreparedGeometryUniquePtr

Unique pointer type for OGRPreparedGeometry.

Since
  GDAL 2.3

## Enumeration Type Documentation

enum OGRWktFormat
| strong

WKT Output formatting options.

Enumerator
F | F-type formatting.
G | G-type formatting.
Default | Format as F when abs(value) < 1, otherwise as G.

## Function Documentation

OGRPreparedGeometry* OGRCreatePreparedGeometry | ( | const OGRGeometry * | poGeom | ) |

Creates a prepared geometry.

To free with OGRDestroyPreparedGeometry()

Parameters

  poGeom | input geometry to prepare.

Returns
  handle to a prepared geometry.

void OGRDestroyPreparedGeometry | ( | OGRPreparedGeometry * | poPreparedGeom | ) |

Destroys a prepared geometry.

Parameters

  poPreparedGeom | preprated geometry.

OGRwkbGeometryType OGRFromOGCGeomType | ( | const char * | pszGeomType | ) |

Map OGCgeometry format type to corresponding OGR constants.

Parameters

  pszGeomType | POINT[ ][Z][M], LINESTRING[ ][Z][M], etc...

Returns
  OGR constant.

int OGRHasPreparedGeometrySupport | ( |  | ) |

Returns if GEOS has prepared geometry support.

Returns
  TRUE or FALSE

int OGRPreparedGeometryContains | ( | const OGRPreparedGeometry * | poPreparedGeom,
|  | const OGRGeometry * | poOtherGeom
| ) |  |

Returns whether a prepared geometry contains a geometry.

Parameters

  poPreparedGeom | prepared geometry.
  poOtherGeom | other geometry.

Returns
  TRUE or FALSE.

int OGRPreparedGeometryIntersects | ( | const OGRPreparedGeometry * | poPreparedGeom,
|  | const OGRGeometry * | poOtherGeom
| ) |  |

Returns whether a prepared geometry intersects with a geometry.

Parameters

  poPreparedGeom | prepared geometry.
  poOtherGeom | other geometry.

Returns
  TRUE or FALSE.

const char* OGRToOGCGeomType | ( | OGRwkbGeometryType | eGeomType | ) |

Map OGR geometry format constants to corresponding OGC geometry type.

Parameters

  eGeomType | OGR geometry type

Returns
  string with OGC geometry type (without dimensionality)